/*
 * libmad_stub.c
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <windows.h>
#include "libmad_stub.h"

int mad_stub_valid=0;
struct mad_stub mad;
static HINSTANCE hLibMAD=NULL;

#define DECL(lib, pfx1, pfx2, sep, id) \
  if (NULL==(pfx1.id=(void *)GetProcAddress(hLib##lib, #pfx2 #sep #id))) \
    goto fail

int mad_stub_load(const char *path, char *p)
{
  strcpy(p, "in_ffsox\\libmad.dll");

  if (NULL==(hLibMAD=LoadLibrary(TEXT(path))))
    goto fail;

  DECL(MAD,mad,mad,_,decoder_init);
  DECL(MAD,mad,mad,_,stream_buffer);
  DECL(MAD,mad,mad,_,header_decode);
  DECL(MAD,mad,mad,_,frame_decode);
  DECL(MAD,mad,mad,_,synth_frame);
  DECL(MAD,mad,mad,_,frame_finish);
  DECL(MAD,mad,mad,_,stream_init);
  DECL(MAD,mad,mad,_,frame_init);
  DECL(MAD,mad,mad,_,synth_init);
  DECL(MAD,mad,mad,_,frame_mute);
  DECL(MAD,mad,mad,_,stream_finish);
  DECL(MAD,mad,mad,_,decoder_finish);

  return mad_stub_valid=1;
fail:
  return mad_stub_unload();
}

#undef DECL

int mad_stub_unload()
{
  if (NULL!=hLibMAD) {
    FreeLibrary(hLibMAD);
    hLibMAD=NULL;
  }

  return mad_stub_valid=0;
}
