/*
 * libmad_stub.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __LIBMAD_STUB_H__
#define __LIBMAD_STUB_H__

#include <mad.h>

extern int mad_stub_valid;

extern struct mad_stub {
  typeof(mad_decoder_init) *decoder_init;
  typeof(mad_stream_buffer) *stream_buffer;
  typeof(mad_header_decode) *header_decode;
  typeof(mad_frame_decode) *frame_decode;
  typeof(mad_synth_frame) *synth_frame;
  typeof(mad_frame_finish) *frame_finish;
  typeof(mad_stream_init) *stream_init;
  typeof(mad_frame_init) *frame_init;
  typeof(mad_synth_init) *synth_init;
  typeof(mad_frame_mute) *frame_mute;
  typeof(mad_stream_finish) *stream_finish;
  typeof(mad_decoder_finish) *decoder_finish;
} mad;

#ifdef __DYNAMIC__
#define mad_decoder_init (*mad.decoder_init)
#define mad_stream_buffer (*mad.stream_buffer)
#define mad_header_decode (*mad.header_decode)
#define mad_frame_decode (*mad.frame_decode)
#define mad_synth_frame (*mad.synth_frame)
#define mad_frame_finish (*mad.frame_finish)
#define mad_stream_init (*mad.stream_init)
#define mad_frame_init (*mad.frame_init)
#define mad_synth_init (*mad.synth_init)
#define mad_frame_mute (*mad.frame_mute)
#define mad_stream_finish (*mad.stream_finish)
#define mad_decoder_finish (*mad.decoder_finish)
#endif

int mad_stub_load(const char *path, char *p);
int mad_stub_unload();

#endif // __LIBMAD_STUB_H__
