/*
 * libsox_stub.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __LIBSOX_STUB_H__
#define __LIBSOX_STUB_H__

#include <sox.h>

extern int sox_stub_valid;

extern struct sox_stub {
  typeof(sox_add_effect) *add_effect;
  typeof(sox_create_effect) *create_effect;
  typeof(sox_create_effects_chain) *create_effects_chain;
  typeof(sox_delete_effects_chain) *delete_effects_chain;
  typeof(sox_effect_options) *effect_options;
  typeof(sox_find_comment) *find_comment;
  typeof(sox_find_effect) *find_effect;
  typeof(sox_flow_effects) *flow_effects;
  typeof(sox_format_quit) *format_quit;
  typeof(sox_init) *init;
  typeof(sox_quit) *quit;
  typeof(sox_read) *read;
  typeof(sox_close) *close;
  typeof(sox_open_read) *open_read;
  typeof(sox_num_comments) *num_comments;
  typeof(sox_format_fns) *format_fns;
} sox;

#ifdef __DYNAMIC__
#define sox_add_effect (*sox.add_effect)
#define sox_create_effect (*sox.create_effect)
#define sox_create_effects_chain (*sox.create_effects_chain)
#define sox_delete_effects_chain (*sox.delete_effects_chain)
#define sox_effect_options (*sox.effect_options)
#define sox_find_comment (*sox.find_comment)
#define sox_find_effect (*sox.find_effect)
#define sox_flow_effects (*sox.flow_effects)
#define sox_format_quit (*sox.format_quit)
#define sox_init (*sox.init)
#define sox_quit (*sox.quit)
#define sox_read (*sox.read)
#define sox_close (*sox.close)
#define sox_open_read (*sox.open_read)
#define sox_num_comments (*sox.num_comments)
#define sox_format_fns (*sox.format_fns)
#endif

int ffmpeg_stub_load(const char *path, char *p);
int ffmpeg_stub_unload();

#endif // __LIBSOX_STUB_H__
